#!/usr/bin/perl

# open a file handle so we can write to the LCD screen
open LCD, ">/dev/ttyUSB0" or die("Couldn't open connection to USB device");

# clear the screen - we'll do this 3 times, so use a subroutine 
clear_screen();

# get the contents of the system command "uptime"
$uptime=`uptime`;

# pick out the relevant bits - uptime, users and current load average
if ($uptime =~ m~up\s+(.*?),\s+(\d+)\s+users?,\s+load average: ([0-9\.]+),~i) {
  $uptime = $1;
  $users  = $2;
  $load   = $3;

  # use the LCD file handle as the default print handle
  # - instead of each print statement starting LCD,
  # this is quicker.
  select LCD;

  # clear the print our info, 
  # wait for 5 seconds before moving on,
  # clear screen before printing more info.
  print "Uptime:\n";
  print "$uptime\n";
  sleep(5);
  clear_screen();
  print "Users:\n";
  print "$users\n";
  sleep(5);
  clear_screen();
  print "Current Load:\n";
  print "$load\n";
  sleep(5);

  # Now we're done printing to LCD,
  # let's go back to STandarD OUTput 
  select STDOUT;
}

# We're finished writing to the LCD, so let's be neat
# and close the file handle we opened at the start
close LCD;

sub clear_screen {
  print LCD chr(254),chr(88);
}